#!/bin/bash
version="0.1.0"

# ARG_OPTIONAL_SINGLE([ref],[r],[Name of the ref associated with this commit. Empty if none.])
# ARG_OPTIONAL_SINGLE([release-type],[t],[The type of releases associated with this commit.])
# ARG_VERSION([echo $version])
# ARG_HELP([])
# ARGBASH_GO()
# needed because of Argbash --> m4_ignore([
### START OF CODE GENERATED BY Argbash v2.9.0 one line above ###
# Argbash is a bash code generator used to get arguments parsing right.
# Argbash is FREE SOFTWARE, see https://argbash.io for more info
# Generated online by https://argbash.io/generate


die()
{
	local _ret="${2:-1}"
	test "${_PRINT_HELP:-no}" = yes && print_help >&2
	echo "$1" >&2
	exit "${_ret}"
}


begins_with_short_option()
{
	local first_option all_short_options='rtvh'
	first_option="${1:0:1}"
	test "$all_short_options" = "${all_short_options/$first_option/}" && return 1 || return 0
}

# THE DEFAULTS INITIALIZATION - OPTIONALS
_arg_ref=
_arg_release_type=


print_help()
{
	printf 'Usage: %s [-r|--ref <arg>] [-t|--release-type <arg>] [-v|--version] [-h|--help]\n' "$0"
	printf '\t%s\n' "-r, --ref: Name of the ref associated with this commit. Empty if none. (no default)"
	printf '\t%s\n' "-t, --release-type: The type of releases associated with this commit. (no default)"
	printf '\t%s\n' "-v, --version: Prints version"
	printf '\t%s\n' "-h, --help: Prints help"
}


parse_commandline()
{
	while test $# -gt 0
	do
		_key="$1"
		case "$_key" in
			-r|--ref)
				test $# -lt 2 && die "Missing value for the optional argument '$_key'." 1
				_arg_ref="$2"
				shift
				;;
			--ref=*)
				_arg_ref="${_key##--ref=}"
				;;
			-r*)
				_arg_ref="${_key##-r}"
				;;
			-t|--release-type)
				test $# -lt 2 && die "Missing value for the optional argument '$_key'." 1
				_arg_release_type="$2"
				shift
				;;
			--release-type=*)
				_arg_release_type="${_key##--release-type=}"
				;;
			-t*)
				_arg_release_type="${_key##-t}"
				;;
			-v|--version)
				echo $version
				exit 0
				;;
			-v*)
				echo $version
				exit 0
				;;
			-h|--help)
				print_help
				exit 0
				;;
			-h*)
				print_help
				exit 0
				;;
			*)
				_PRINT_HELP=yes die "FATAL ERROR: Got an unexpected argument '$1'" 1
				;;
		esac
		shift
	done
}

parse_commandline "$@"

# OTHER STUFF GENERATED BY Argbash

### END OF CODE GENERATED BY Argbash (sortof) ### ])

if [ -z "${_arg_release_type}" ]; then die "Release type must be specified!" 1

version=""

if [[ "${_arg_release_type}" == "stable" ]]; then

    version=${_arg_ref}

elif [[ "${_arg_release_type}" == "stable" ]]; then

    release_type="release-candidate"

else

    die "Unexpected release type encountered: ${_arg_release_type}" 1

fi

echo ${version}
